<?php
include_once("inc/simple_html_dom.php");
include_once("post_type/get_news.php");
include_once("acf/acf.php");
include_once("inc/func_test.php");
include_once("ajax/ajax_show_post.php");
include_once("ajax/ajax_save_post.php");
function get_web_page($url)
{
    $user_agent = 'Mozilla/5.0 (Windows NT 6.1; rv:8.0) Gecko/20100101 Firefox/8.0';

    $options = array(

        CURLOPT_CUSTOMREQUEST => "GET",        //set request type post or get
        CURLOPT_POST => false,        //set to GET
        CURLOPT_USERAGENT => $user_agent, //set user agent
        CURLOPT_COOKIEFILE => "cookie.txt", //set cookie file
        CURLOPT_COOKIEJAR => "cookie.txt", //set cookie jar
        CURLOPT_RETURNTRANSFER => true,     // return web page
        CURLOPT_HEADER => false,    // don't return headers
        CURLOPT_FOLLOWLOCATION => true,     // follow redirects
        CURLOPT_ENCODING => "",       // handle all encodings
        CURLOPT_AUTOREFERER => true,     // set referer on redirect
        CURLOPT_CONNECTTIMEOUT => 120,      // timeout on connect
        CURLOPT_TIMEOUT => 120,      // timeout on response
        CURLOPT_MAXREDIRS => 10,       // stop after 10 redirects
        CURLOPT_SSL_VERIFYPEER => false,     // Disabled SSL Cert checks
    );

    $ch = curl_init($url);
    curl_setopt_array($ch, $options);
    $content = curl_exec($ch);
    $err = curl_errno($ch);
    $errmsg = curl_error($ch);
    $header = curl_getinfo($ch);
    curl_close($ch);

    $header['errno'] = $err;
    $header['errmsg'] = $errmsg;
    $header['content'] = $content;
    return $header;
}

function check_url($url)
{
    if (filter_var($url, FILTER_VALIDATE_URL)) {
        return true;
    } else {
        return false;
    }
}

function get_server_name($url)
{
    if (!$url) return false;
    $link = parse_url($url);
    return $link['scheme'] . '://' . $link['host'];
}

function save_img_wp($url)
{
    $upload_dir = wp_upload_dir(); // Set upload folder
    $image_data = get_web_page($url); // Get image data
    $filename = basename($url); // Create image file name

// Check folder permission and define file location
    if (wp_mkdir_p($upload_dir['path'])) {
        $file = $upload_dir['path'] . '/' . $filename;
    } else {
        $file = $upload_dir['basedir'] . '/' . $filename;
    }

// Create the image  file on the server
    file_put_contents($file, $image_data['content']);

// Check image file type
    $wp_filetype = wp_check_filetype($filename, null);

// Set attachment data
    $attachment = array(
        'post_mime_type' => $wp_filetype['type'],
        'post_title' => sanitize_file_name($filename),
        'post_content' => '',
        'post_status' => 'inherit'
    );

// Create the attachment
    $attach_id = wp_insert_attachment($attachment, $file);
    $attach_data = wp_generate_attachment_metadata($attach_id, $file);
    wp_update_attachment_metadata($attach_id, $attach_data);

    return wp_get_attachment_url($attach_id, 'full');
}


function save_thumnail_post_wp($ID, $url)
{
    $parent_post_id = $ID;
    $upload_dir = wp_upload_dir(); // Set upload folder
    $image_data = get_web_page($url); // Get image data
    $filename = basename($url); // Create image file name

// Check folder permission and define file location
    if (wp_mkdir_p($upload_dir['path'])) {
        $file = $upload_dir['path'] . '/' . $filename;
    } else {
        $file = $upload_dir['basedir'] . '/' . $filename;
    }

// Create the image  file on the server
    file_put_contents($file, $image_data['content']);

// Check image file type
    $wp_filetype = wp_check_filetype($filename, null);

// Set attachment data
    $attachment = array(
        'post_mime_type' => $wp_filetype['type'],
        'post_title' => sanitize_file_name($filename),
        'post_content' => '',
        'post_status' => 'inherit'
    );

    $attach_id = wp_insert_attachment($attachment, $file);
    $attach_data = wp_generate_attachment_metadata($attach_id, $file);
    wp_update_attachment_metadata($attach_id, $attach_data);
    set_post_thumbnail($parent_post_id, $attach_id);
}


function wp_exist_post_by_title($title, $post_type = 'post')
{
    global $wpdb, $table_prefix;
    $return = $wpdb->get_row("SELECT ID FROM " . $wpdb->base_prefix . "posts WHERE post_title = '" . $title . "'  && post_type = '{$post_type}' ", 'ARRAY_N');
    if (empty($return)) {
        return false;
    } else {
        return true;
    }
}
function my_add_intervals($schedules) {
    // add a 'weekly' interval
    $schedules['minute'] = array(
        'interval' => 600,
        'display' => __('Once minute'),
    );

    return $schedules;
}
add_filter( 'cron_schedules', 'my_add_intervals');



if (!wp_next_scheduled('pt_my_task_hook')) {
    wp_schedule_event(time(), 'minute', 'pt_my_task_hook');
}
add_action('pt_my_task_hook', 'update_check_post');
function update_check_post()
{
    global $wpdb;

    $args = array(
        'posts_per_page' => -1,
        'offset' => 0,
        'post_type' => 'get_news',
        'post_status' => 'publish',
        'suppress_filters' => true
    );
    $posts_array = get_posts($args);
    foreach ($posts_array as $post) {
        $update = get_field('update', $post->ID);
        $list_link_site = get_field('list_link_site', $post->ID);
        if ($update & $list_link_site) {
            foreach ($list_link_site as $key => $link) {

                /*Thong tin lay tin*/
                $list_link_site[$key]['domain_site'] = get_field('domain_site', $post->ID);
                $list_link_site[$key]['css_title'] = get_field('css_title', $post->ID);
                $list_link_site[$key]['css_content'] = get_field('css_content', $post->ID);
                $list_link_site[$key]['css_delete'] = get_field('css_delete', $post->ID);
                $list_link_site[$key]['type'] = get_field('type', $post->ID);
                $list_link_site[$key]['status'] = get_field('status', $post->ID);
                $all['link_site'][$post->ID][$key] = [$key];
            }
            $all_data[$post->ID] = $list_link_site;

        }

    }

    if (!$all['link_site']) return false;
    foreach ($all['link_site'] as $key => $link) {
        foreach ($link as $key2 => $value) {
            $array_links[] = $all_data[$key][$key2];
        }
    }
    if (!$array_links) return false;

    foreach ($array_links as $items) {
        $result = get_web_page($items['link_site']);
        $page_html = $result['content'];
        $HTML = str_get_html($page_html);
        $links = $HTML->find($items['css_link']);
        $images = $HTML->find($items['css_image']);
        foreach ($links as $link) {
            preg_match('/href="([^"]+)/i', trim($link->outertext), $a_link);
            $url = str_ireplace('href="', '', $a_link[0]);
            if (check_url($url)) {
                $array_link[] = $url;
            } else {
                $array_link[] = get_server_name($items['link_site']) . $url;
            }


            $array_data[] = $items;

        }

        for ($i = 0; $i < count($links); $i++) {
            if ($images[$i]) {
                preg_match('/src="([^"]+)/i', trim($images[$i]->outertext), $img_link);
                $array_images[] = str_ireplace('src="', '', $img_link[0]);
            } else {
                $array_images[] = GNW_URL . '/images/image_auto.jpg';
            }

        }


    }


    if ($array_link) {
        $array_link = array_filter($array_link);
        $count = 0;
        foreach ($array_link as $key => $link) {
            if ($count < 1) {
                if (check_post_by_meta_value('link',$link) == false) {
                    $count++;
                    $array_post[] = array(
                        'data-title' => $array_data[$key]['css_title'],
                        'data-content' => $array_data[$key]['css_content'],
                        'data-href' => $link,
                        'data-image' => $array_images[$key],
                        'data-delete' => $array_data[$key]['css_delete'],
                        "data-type" => $array_data[$key]['type'],
                        'data-status' => $array_data[$key]['status'],
                    );
                }

            }
        }
    }

    if ($array_post) {
        foreach ($array_post as $array) {
            $content_array = $img_save = array();
            $link = $array['data-href'];
            $css_title = $array['data-title'];
            $css_content = $array['data-content'];
            $link_image = $array['data-image'];
            $delete = $array['data-delete'];
            $type = $array['data-type'];
            $status = $array['data-status'];
            if (empty($link)) return false;
            $result = get_web_page($link);
            if (!$result) return false;
            $page_html = $result['content'];
            $HTML = str_get_html($page_html);
            $HTML->find($delete,0)->outertext = '';
            $HTML->load($HTML->save());
            if (!$css_title) return false;
            $title = $HTML->find($css_title);
            $content = $HTML->find($css_content);
            //  $array['data-price'] = $HTML->find($array['data-price'],0)->innertext;
           // test_insert_post();
            foreach ($title as $item) {
                $title = $item->innertext;
            }
            foreach ($content as $item) {
                preg_match_all('/href="([^"]+)/i', trim($item->outertext), $link_d);
                $content_array[] = str_replace($link_d[0], 'ref="#', trim($item->outertext));
                preg_match_all('/src="([^"]+)/i', trim($item->outertext), $imgage);
                $img = str_replace('src="', '', $imgage[0]);
            }

            for ($j = 0; $j < count($img); $j++) {
              //  $img_save[] = save_img_wp($img[$j]);
            }

          //  $content_array = str_replace($img, $img_save, $content_array);
            if ($content_array):
                $user_ID = get_current_user_id();
                $title = str_replace("'",'',$title);
                if (wp_exist_post_by_title($title, $type) == false) {
                    $my_post = array(
                        'post_type' => $type,
                        'post_author' => $user_ID,
                        'post_parent' => 0,
                        'menu_order' => 0,
                        'post_title' => $title,
                        'post_status' => $status,
                    );
                    $my_post['post_content'] = $content_array[0];
                    $ID = wp_insert_post($my_post);
                    add_post_meta($ID, 'link', $link, true);
                  //  save_thumnail_post_wp($ID, $link_image);
                    die();
                }


            endif;

        }
    }

    die();

}

function test_insert_post(){
    $my_post = array(
        'post_type' => 'post',
        'post_parent' => 0,
        'menu_order' => 0,
        'post_title' => 'title-'.time(),
        'post_status' => 'publish',
    );
    $ID = wp_insert_post($my_post);
}

function check_post_by_meta_value($key,$value){
    global $wpdb;
    $posts = $wpdb->get_results("SELECT * FROM $wpdb->postmeta
WHERE meta_key = '{$key}' AND  meta_value = '{$value}' LIMIT 1", ARRAY_A);
    if($posts) return true;
    return false;
}